searchNodes=[{"doc":"A Library of Useful functions for building Elixir Apps.","ref":"Useful.html","title":"Useful","type":"module"},{"doc":"atomize_map_keys/1 converts a Map with different keys to a map with just atom keys. Works recursively for nested maps. Inspired by stackoverflow.com/questions/31990134Examplesiex&gt; Useful.atomize_map_keys(%{&quot;name&quot; =&gt; &quot;alex&quot;, id: 1}) %{id: 1, name: &quot;alex&quot;} iex&gt; Useful.atomize_map_keys(%{&quot;name&quot; =&gt; &quot;alex&quot;, data: %{ &quot;age&quot; =&gt; 17}}) %{name: &quot;alex&quot;, data: %{age: 17}}","ref":"Useful.html#atomize_map_keys/1","title":"Useful.atomize_map_keys/1","type":"function"},{"doc":"flatten_map/1 flattens a Map of any depth/nesting for easier processing. Deeply nested maps are denoted by &quot;&quot; (double underscore) e.g: %{name: Alex, detail: %{age: 17}} becomes `%{name: Alex, detailage: 17}` this makes it easy to see what the data structure was before flattening. Map keys are converted to Atom for simpler access and consistency. Inspired by: https://stackoverflow.com/questions/39401947/flatten-nested-mapExamplesiex&gt; map = %{name: &quot;alex&quot;, data: %{age: 17, height: 185}} iex&gt; Useful.flatten_map(map) %{data__age: 17, data__height: 185, name: &quot;alex&quot;}","ref":"Useful.html#flatten_map/1","title":"Useful.flatten_map/1","type":"function"},{"doc":"stringy_map/1 converts a Map of any depth/nesting into a string. Deeply nested maps are denoted by &quot;__&quot; (double underscore). See flatten_map/1 for more details.Examplesiex&gt; map = %{name: &quot;alex&quot;, data: %{age: 17, height: 185}} iex&gt; Useful.stringify_map(map) &quot;data__age: 17, data__height: 185, name: alex&quot;","ref":"Useful.html#stringify_map/1","title":"Useful.stringify_map/1","type":"function"},{"doc":"stringify_tuple/1 stringifies a Tuple with arbitrary values. Handy when you want to print out a tuple during debugging.Examplesiex&gt; tuple = {:name, &quot;alex&quot;} iex&gt; Useful.stringify_tuple(tuple) &quot;name: alex&quot;","ref":"Useful.html#stringify_tuple/1","title":"Useful.stringify_tuple/1","type":"function"},{"doc":"typeof/1 returns the type of a vairable. Inspired by stackoverflow.com/questions/28377135/check-typeof-variable-in-elixirExamplesiex&gt; Useful.typeof(:atom) &quot;atom&quot; iex&gt; bin = &quot;hello&quot; iex&gt; Useful.typeof(bin) &quot;binary&quot; iex&gt; bitstr = &lt;&lt;1::3&gt;&gt; iex&gt; Useful.typeof(bitstr) &quot;bitstring&quot; iex&gt; Useful.typeof(:true) &quot;boolean&quot; iex&gt; pi = 3.14159 iex&gt; Useful.typeof(pi) &quot;float&quot; iex&gt; fun = fn (a, b) -&gt; a + b end iex&gt; Useful.typeof(fun) &quot;function&quot; iex&gt; Useful.typeof(&amp;Useful.typeof/1) &quot;function&quot; iex&gt; int = 42 iex&gt; Useful.typeof(int) &quot;integer&quot; iex&gt; list = [1,2,3,4] iex&gt; Useful.typeof(list) &quot;list&quot; iex&gt; map = %{:foo =&gt; &quot;bar&quot;, &quot;hello&quot; =&gt; :world} iex&gt; Useful.typeof(map) &quot;map&quot; iex&gt; Useful.typeof(nil) &quot;nil&quot; iex&gt; pid = spawn(fn -&gt; 1 + 2 end) iex&gt; Useful.typeof(pid) &quot;pid&quot; iex&gt; port = Port.open({:spawn, &quot;cat&quot;}, [:binary]) iex&gt; Useful.typeof(port) &quot;port&quot; iex&gt; ref = :erlang.make_ref iex&gt; Useful.typeof(ref) &quot;reference&quot; iex&gt; tuple = {:name, &quot;alex&quot;} iex&gt; Useful.typeof(tuple) &quot;tuple&quot;","ref":"Useful.html#typeof/1","title":"Useful.typeof/1","type":"function"}]